#include "system/task_crc.h"
#include "system/data_channel.h"
#include "system/float_word.h"
//#include <zlib.h> 				/* c-library for crc32() */
#include <stddef.h>					/* for "size_t" */
#include <stdio.h>

#if 0
#define PRINT_DEBUG_VALUES
#endif


/* used basic algo from and modified it: https://lxp32.github.io/docs/a-simple-example-crc32-calculation/*/
uint32_t crc32(uint32_t *crc_res, const char *s,size_t n) 
{
	uint32_t crc = ~(*crc_res);		// always invert the input!

	#ifdef PRINT_DEBUG_VALUES
	printf("SIZE OF SEED, INPUT & OUTPUT: %i\n", n);	
	printf("SEED:    %08x\n", *crc_res);	
	printf("INPUT:   %08x\n", *(uint32_t*)s);
	#endif /*PRINT_DEBUG_VALUES*/
	
	for(size_t i=0;i<n;++i) 
	{
		unsigned char ch=s[i];

		#ifdef PRINT_DEBUG_VALUES
		printf("ch: %02x\n", ch);
		#endif /*PRINT_DEBUG_VALUES*/

		for(size_t j=0;j<8;++j) {
				uint32_t b=(ch^crc)&1;
				crc>>=1;
				//if(b) crc=crc^0x04C11DB7; // Polynomial representations: NORMAL
				if(b) crc=crc^0xEDB88320; // Polynomial representations: REVERSED
				ch>>=1;
		}
	}

	#ifdef PRINT_DEBUG_VALUES
	printf("OUTPUT:  %08x\n", crc);
	printf("~OUTPUT: %08x\n", ~crc);
	getchar();		// just here for debugging step by step
	#endif /*PRINT_DEBUG_VALUES*/

	return ~crc;
}




int task_crc_run( void * task )
{
    // TODO

	crc_config * crc = ( crc_config * ) task;
	uint32_t data_channel_base = crc->base.sink;
	data_channel_clear( data_channel_base);
		
	float_word crc_res;
	float_word crc_input;

	crc_res.word = crc->start;

	for ( uint32_t i = 0; i < DATA_CHANNEL_DEPTH; ++i )
	{
		data_channel_read(crc->base.sources[0], (uint32_t*)&crc_input.value);
		crc_res.word = crc32(&crc_res.word,(const void *)&crc_input, sizeof(crc_input));
	}

	data_channel_write( data_channel_base, crc_res.word );

    return 0;
}

